import { system, world, ItemStack, Player } from '@minecraft/server'
import { ActionFormData, ModalFormData } from '@minecraft/server-ui'

console.warn("Successfully loaded script!")

world.afterEvents.playerSpawn.subscribe((event) => {
	const player = event.player
	const link = new ItemStack("nimp:neural_link", 1)

	if (player.getDynamicProperty("cyberEnhanced") != true) {
		player.setDynamicProperty("cyberEnhanced", true)
		link.keepOnDeath = true

		player.dimension.spawnItem(link, player.location)
	}
})

world.afterEvents.itemUse.subscribe((event) => {
	const item = event.itemStack
	const player = event.source
	const inv = player?.getComponent("inventory").container

	if (item.typeId == "nimp:neural_link" && player.isSneaking == false) {
		const form = new ActionFormData()
			.title("Neuro-Genesis Link System")
			.button("Activate Vision Implant")
			.button("Activate Sub-Dermal Armor")
			.button("Activate Titan Calves")
			.button("Activate Spring-Loaded Legs")
			.button("ACtivate Military Knuckles")
			.button("Activate Motorized Elbows")
		form.show(player).then(formData => {
			if (formData.selection == 0) {
				if (player.getDynamicProperty("vision_implant") == true) {
					player.addEffect("night_vision", 500, { showParticles: false })
					player.removeEffect("blindness")
					player.removeEffect("darkness")
				}
				else if (player.getDynamicProperty("vision_implant") != true) {
					player.sendMessage("You don't have a vision implant!")
				}
			}

			if (formData.selection == 1) {
				if (player.getDynamicProperty("skin_implant") == true) {
					player.addEffect("resistance", 500, { showParticles: false })
				}
				else if (player.getDynamicProperty("skin_implant") != true) {
					player.sendMessage("You don't have sub-dermal armor!")
				}
			}

			if (formData.selection == 2) {
				if (player.getDynamicProperty("calf_implant") == true) {
					player.addEffect("speed", 500, { showParticles: false })
				}
				else if (player.getDynamicProperty("calf_implant") != true) {
					player.sendMessage("You don't have titan calves!")
				}
			}

			if (formData.selection == 3) {
				if (player.getDynamicProperty("leg_implant") == true) {
					player.addEffect("jump_boost", 500, { showParticles: false })
				}
				else if (player.getDynamicProperty("leg_implant") != true) {
					player.sendMessage("You don't have spring-loaded legs!")
				}
			}

			if (formData.selection == 4) {
				if (player.getDynamicProperty("fist_implant") == true) {
					player.addEffect("strength", 500, { showParticles: false })
				}
				else if (player.getDynamicProperty("fist_implant") != true) {
					player.sendMessage("You don't have military knuckles!")
				}
			}

			if (formData.selection == 5) {
				if (player.getDynamicProperty("elbow_implant") == true) {
					player.addEffect("haste", 500, { showParticles: false })
				}
				else if (player.getDynamicProperty("elbow_implant") != true) {
					player.sendMessage("You don't have motorized elbows!")
				}
			}
		})
	}
	else if (item?.typeId == "nimp:neural_link" && player.isSneaking == true) {
		if (player.getDynamicProperty("automated") == true && player.getDynamicProperty("disableAutomations") == false) {
			player.setDynamicProperty("disableAutomations", true)
			player.playSound("block.end_portal_frame.fill")
			player.sendMessage("Automations disabled.")
		}
		else if (player.getDynamicProperty("automated") == true && player.getDynamicProperty("disableAutomations") == true) {
			player.setDynamicProperty("disableAutomations", false)
			player.playSound("block.end_portal_frame.fill")
			player.sendMessage("Automations enabled.")
		}
	}

	if (player.isSneaking == true && item?.typeId == "nimp:vision_implant" && player.getDynamicProperty("vision_implant") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("vision_implant", true)
		player.sendMessage("You've just installed a new vision implant. You go dizzy for a bit as you get used to it...")
		player.addEffect("darkness", 200, { showParticles: false })
	}

	if (player.isSneaking == true && item?.typeId == "nimp:armor_implant" && player.getDynamicProperty("skin_implant") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("skin_implant", true)
		player.sendMessage("You've just installed a new armor implant. You feel sensitive for a bit as you get used to it...")
		player.addEffect("weakness", 200, { showParticles: false })
	}

	if (player.isSneaking == true && item?.typeId == "nimp:calf_implant" && player.getDynamicProperty("calf_implant") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("calf_implant", true)
		player.sendMessage("You've just installed a new calf implant. You feel slow for a bit as you get used to it...")
		player.addEffect("slowness", 200, { showParticles: false })
	}

	if (player.isSneaking == true && item?.typeId == "nimp:leg_implant" && player.getDynamicProperty("leg_implant") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("leg_implant", true)
		player.sendMessage("You've just installed a new thigh implant. You feel slow for a bit as you get used to it...")
		player.addEffect("slowness", 200, { showParticles: false })
	}

	if (player.isSneaking == true && item?.typeId == "nimp:fist_implant" && player.getDynamicProperty("fist_implant") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("fist_implant", true)
		player.sendMessage("You've just installed a new fist implant. You feel weak for a bit as you get used to it...")
		player.addEffect("weakness", 200, { showParticles: false })
	}

	if (player.isSneaking == true && item?.typeId == "nimp:elbow_implant" && player.getDynamicProperty("elbow_implant") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("elbow_implant", true)
		player.sendMessage("You've just installed a new elbow implant. You have a hard time mining for a bit as you get used to it...")
		player.addEffect("mining_fatigue", 200, { showParticles: false })
	}

	if (player.isSneaking == true && item?.typeId == "nimp:automation_upgrade" && player.getDynamicProperty("automated") != true) {
		inv.setItem(player.selectedSlotIndex, null)
		player.playSound("random.break")
		player.setDynamicProperty("automated", true)
		player.setDynamicProperty("disableAutomations", false)
		player.sendMessage("You've just installed a new automation chip. You feel weak for a bit as you get used to it...")
		player.sendMessage("You can use the link device to enable/disable automations.")
		player.addEffect("weakness", 200, { showParticles: false })
	}
})

world.afterEvents.entityHurt.subscribe((event) => {
	const source = event.damageSource
	const damage = event.damage
	const target = event.hurtEntity

	if (target instanceof Player) {
		const player = target

		if (player.getComponent("minecraft:health").currentValue <= 6 && player.getDynamicProperty("skin_implant") == true && player.getDynamicProperty("disableAutomations") == false) {
			player.addEffect("resistance", 400, { showParticles: false, amplifier: 3 })
			player.addEffect("regeneration", 400, { showParticles: false, amplifier: 2 })
		}
	}

	if (source.damagingEntity instanceof Player) {
		const player = source.damagingEntity
		const item = player.getComponent("equippable").getEquipment("Mainhand")



		if (target.hasComponent("minecraft:health") == true && player.getDynamicProperty("fist_implant") == true && player.getDynamicProperty("disableAutomations") == false) {
			player.addEffect("strength", 100, { showParticles: false, amplifier: 0 })
		}
	}
})

world.afterEvents.playerBreakBlock.subscribe((event) => {
	const player = event.player
	const block = event.block

	if (player.getDynamicProperty("disableAutomations") == false && player.getDynamicProperty("elbow_implant") == true) {
		player.addEffect("haste", 100, { showParticles: false, amplifier: 1 })
	}
})

function autoSpeed() {
	system.runInterval(() => {
		for (const player of world.getPlayers()) {
			const height = player.location.y

			if (player?.getDynamicProperty("disableAutomations") == false && player.getDynamicProperty("calf_implant") == true && player.isSprinting == true) {
				player.addEffect("speed", 5, { showParticles: false, amplifier: 0 })
			}

			if (player?.getDynamicProperty("disableAutomations") == false && player.getDynamicProperty("leg_implant") == true && player.isSneaking == true) {
				player.addEffect("jump_boost", 5, { showParticles: false, amplifier: 2 })
			}

			if ((world.getTimeOfDay() > 12610 || world.getTimeOfDay() < 1000) && player?.getDynamicProperty("disableAutomations") == false && player.getDynamicProperty("vision_implant") == true) {
				player.addEffect("night_vision", 1000, { showParticles: false, amplifier: 0 })
			}
		}
	})
}

system.run(autoSpeed)